<div align="center">

# erte

[![npm version](https://badge.fury.io/js/erte.svg)](https://www.npmjs.com/package/erte)
[![Build status](https://ci.appveyor.com/api/projects/status/61wjo8vbokub9afe?svg=true)](https://ci.appveyor.com/project/bulbazaur/erte)
<a href="https://gitlab.com/artdeco/erte/-/commits/master">
  <img src="https://gitlab.com/artdeco/erte/badges/master/pipeline.svg" alt="Pipeline Badge">
</a>

</div>

`erte` Colors Strings' Foreground And Background And Shows String Difference With Color.

```sh
yarn add -E erte
```

<div align="center"><a href="#table-of-contents">
  <img src="/.documentary/section-breaks/0.svg?sanitize=true">
</a></div>

## Table Of Contents

<a href="https://www.artd.eco"><img align="right" src="doc/woman.jpg" width="225" alt="erte" /></a>

- [Table Of Contents](#table-of-contents)
- [API](#api)
  * [`Color`](#type-color)
- [`erte(source: string, target: string): string`](#ertesource-stringtarget-string-string)
- [`c(string: string, color: Color): string`](#cstring-stringcolor-color-string)
- [`b(string: string, color: Color): string`](#bstring-stringcolor-color-string)
- [Copyright & License](#copyright--license)

<div align="center"><a href="#table-of-contents">
  <img src="/.documentary/section-breaks/1.svg?sanitize=true">
</a></div>

## API

The package is available by importing its default and named functions:

```js
import erte, { c, b } from 'erte'
```

<code>('black' \| 'red' \| 'green' \| 'yellow' \| 'blue' \| 'magenta' \| 'cyan' \| 'white' \| 'grey')</code> __<a name="type-color">`Color`</a>__: The color to apply.

<div align="center"><a href="#table-of-contents">
  <img src="/.documentary/section-breaks/2.svg?sanitize=true">
</a></div>

## <code><ins>erte</ins>(</code><sub><br/>&nbsp;&nbsp;`source: string,`<br/>&nbsp;&nbsp;`target: string,`<br/></sub><code>): <i>string</i></code>
Compares the strings using the [`diff`](https://www.npmjs.com/package/diff) package,
and outputs a coloured version where strings don't match with green or red differences.
Returns a string which uses shell-codes to highlight differences.

 - <kbd><strong>source*</strong></kbd> <em>`string`</em>: The string to compare.
 - <kbd><strong>target*</strong></kbd> <em>`string`</em>: The string to comparison against.

```js
import erte from 'erte'

const s = 'test this string'
const e = 'test this string with extra data'
const m = 'test this'

const green = erte(s, e)
console.log(green)

const red = erte(s, m)
console.log(red)

const grey = erte(s, s)
console.log(grey)
```
```
test this string with extra data
test this string
test this string
```

![extra](doc/extra.png)

![missing](doc/missing.png)

![same](doc/same.png)

<div align="center"><a href="#table-of-contents">
  <img src="/.documentary/section-breaks/3.svg?sanitize=true">
</a></div>

## <code><ins>c</ins>(</code><sub><br/>&nbsp;&nbsp;`string: string,`<br/>&nbsp;&nbsp;`color: Color,`<br/></sub><code>): <i>string</i></code>
Colors the foreground using an ANSI sequence.

 - <kbd><strong>string*</strong></kbd> <em>`string`</em>: The string to color.
 - <kbd><strong>color*</strong></kbd> <em><code><a href="#type-color" title="The color to apply.">Color</a></code></em>: The color to use.

```js
import { c } from 'erte'

const redText = c('RED ALERT', 'red')
console.log(redText)
```

![c](doc/c.png)

<div align="center"><a href="#table-of-contents">
  <img src="/.documentary/section-breaks/4.svg?sanitize=true">
</a></div>

## <code><ins>b</ins>(</code><sub><br/>&nbsp;&nbsp;`string: string,`<br/>&nbsp;&nbsp;`color: Color,`<br/></sub><code>): <i>string</i></code>
Colors the background with specified ANSI color.

 - <kbd><strong>string*</strong></kbd> <em>`string`</em>: The string to color.
 - <kbd><strong>color*</strong></kbd> <em><code><a href="#type-color" title="The color to apply.">Color</a></code></em>: The color to use.

```js
import { b } from 'erte'

const greenText = b('VEGAN', 'green')
console.log(greenText)
```

![b](doc/b.png)

<div align="center"><a href="#table-of-contents">
  <img src="/.documentary/section-breaks/5.svg?sanitize=true">
</a></div>

## Copyright & License

The `diff` package is released under [BSD License](COPYING) by [Kevin Decker](https://github.com/kpdecker/jsdiff). [Artwork by Erte][3].

GNU Affero General Public License v3.0

<table>
  <tr>
    <th>
      <a href="https://www.artd.eco">
        <img width="100" src="https://raw.githubusercontent.com/wrote/wrote/master/images/artdeco.png"
          alt="Art Deco">
      </a>
    </th>
    <th>© <a href="https://www.artd.eco">Art Deco™</a>   2020</th>
    <th><a href="LICENSE"><img src=".documentary/agpl-3.0.svg" alt="AGPL-3.0"></a></th>
  </tr>
</table>

[2]: https://www.npmjs.com/package/diff
[3]: http://www.erte.com

<div align="center"><a href="#table-of-contents">
  <img src="/.documentary/section-breaks/-1.svg?sanitize=true">
</a></div>