/**
 * @fileoverview
 * @externs
 */

/* typal types/api.xml externs */
/** @const */
var _erte = {}
/**
 * Compares the strings using the [`diff`](https://www.npmjs.com/package/diff) package,
and outputs a coloured version where strings don't match with green or red differences.
Returns a string which uses shell-codes to highlight differences.
 * @typedef {function(string,string): string}
 */
_erte.erte
/**
 * Colors the foreground using an ANSI sequence.
 * @typedef {function(string,_erte.Color): string}
 */
_erte.c
/**
 * Colors the background with specified ANSI color.
 * @typedef {function(string,_erte.Color): string}
 */
_erte.b

/* typal types/index.xml externs */
/**
 * The color to apply.
 * @typedef {string}
 */
_erte.Color
